from flask import Flask, request, jsonify
from flask_restful import Resource, Api
from sqlalchemy import create_engine
import mysql.connector as mariadb
from flask import g
from flask import Response
from flask import request
import json
import hashlib
import random
import uuid
from enum import Enum
import array as arr
import time, threading,datetime
from datetime import timedelta
import sys
import Adafruit_DHT
import RPi.GPIO as GPIO
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
from dateutil import parser
import logging
import os.path as path
from flask import session
#import ControlMail
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
import smtplib
import random

db_connect = create_engine('mysql+pymysql://usuario:password@localhost:3306/DOMOTIC')

app = Flask(__name__)
api = Api(app)


idsession = 0
token = ''
activarControlSession = False
now = datetime.datetime.now()
filePath = 'domotic.log'



PrimeraVez = True


def BucleControlAgua():
  iDGPIO = 17

  GPIO.setup(iDGPIO, GPIO.IN, GPIO.PUD_UP)
  
  logging.info('Inicio control agua')
  GenerarEvento('Inicio control agua')
  
  with app.app_context():
    try:
      while True:
        estado = GPIO.input(iDGPIO)
        
        if estado == ' ':
          GenerarEvento('Problema con la comunicacion -> flotador de agua')
          logging.info('Problema con la comunicacion -> flotador de agua')
          IdTipoSensor = int(TipoDispositivo.Flotador.value)
          IdEstado = int(EstadoSensor.Fallo.value)
          # ~ cadena = "INSERT INTO TEstados (Sensor, Descripcion, Estado) VALUES ('%d','%s','%d')" % (1,'Fallo lectura flotador',0)
          # ~ resultado= query_modificar(cadena)
                
        if estado == GPIO.LOW:
          print ("Nivel de agua bajo")
          GenerarEvento('Nivel del agua bajo')
          logging.info('Nivel de agua bajo')
          
          GPIO.setmode(GPIO.BCM) 
          GPIO.setup(23, GPIO.OUT)
          
          GPIO.output(23, GPIO.HIGH)
          
          time.sleep(5)
          GPIO.output(23, GPIO.LOW)
          logging.info('Estado del agua llenandose')
          GenerarEvento('Estado del agua llenandose')
         
          print "estado",estado
               
          if estado == GPIO.HIGH:
             #GPIO.output(23, GPIO.LOW)
             print "el agua ha sudido"
             GenerarEvento('El agua ha subido, bebedero ok')
             logging.debug('El agua ha sudido, bebedero ok')
             
    except:
      raise
  
def BucleAmbiente():
  
  logging.info('Bucle ambiente on')
  GenerarEvento('Bucle ambiente on')
  
  time.sleep(10)    
  with app.app_context():
    db_connect()
      
    while True:
      ahora = datetime.datetime.now()
      
      humidity, temperature = Adafruit_DHT.read_retry(11, 4)
            
      if humidity is not None and temperature is not None:
        
        cadena= "INSERT INTO TAmbiente (Temperatura, Humedad, Fecha) VALUES ('%.2f', '%.2f', '%s')" % (temperature, humidity, str(ahora))
        result = query_modificar(cadena)
        
        time.sleep(120)
        cadena2 = "INSERT INTO TEstados (Sensor, Descripcion,Estado) VALUES ('%d','%s','%d')" % (4,'Sensor temperatura activo',1)
        resultado= query_modificar(cadena2)
        

def ActivarThreadAmbiente():
    timerThread2 = threading.Thread(target=BucleAmbiente)
    timerThread2.daemon = True
    timerThread2.start()

def ActivarThreadControlFlotador():
    timerThread3 = threading.Thread(target=BucleControlAgua)
    timerThread3.daemon = True
    timerThread3.start()


def ActivarThreadGenerarEvento():
    timerThread3 = threading.Thread(target=GenerarEvento)
    timerThread3.daemon = True
    timerThread3.start()



def RefreshToken(token):
  
  now = datetime.datetime.now()
  
  cadena = "UPDATE TSesiones SET Fecha = '%s'" % str(now)
  result = query_modificar(cadena)
  
@app.route('/ambiente/<fecha>/<token>', methods=['GET'])
def GetAmbiente(fecha ,token):
    
   if ControlToken(token) == 1: 
      RefrescarFechaSession()
      
      fecha = datetime.datetime.now()
      
      #while True:
      arrayAmbiente = Adafruit_DHT.read_retry(11, 4)
      temp = arrayAmbiente[1]
      humi = arrayAmbiente[0]
      time.sleep(0.5)
      #break
      print temp
      print humi
      
      #CodigoOper = int(OperationCode.OK.value)
      data = {'Resultado':[{'OperationCode': 0,  'Temperatura': temp, 'Humedad': humi, 'Message' : 'GetAmbiente'}]}
      data = json.dumps(data)
      resp = Response(data, status=200, mimetype='application/json')
      return resp
   else:
      CodigoOper = int(OperationCode.Err.value)
      data = {'Resultado':[{'OperationCode': 0, 'Message': 'GetAmbiente'}]}
      data = json.dumps(data)
      resp = Response(data, status=400, mimetype='application/json')
      return resp

def ControlSession():
  global now
  now = datetime.datetime.now()
  
  dt = datetime
  
  global activarControlSession

  with app.app_context():
      db_connect()
      
      cadena = "SELECT Fecha FROM TSesiones where Token = '%s'" % str(token)
      fechaBBDD = query_select(cadena)
      
      dt = fechaBBDD + datetime.timedelta(seconds=1200)
            
      activar = False
      while now < dt:
          activar = True
          
          now = datetime.datetime.now()
          time.sleep(5)
                             
          cadena = "SELECT Fecha FROM TSesiones where token = '%s'" % (str(token))
          fechaRefresh = query_select(cadena)
                   
          refresco()
          
          if fechaRefresh < dt:
            continue
          else:
            while fechaRefresh > now:
              now = datetime.datetime.now()
              cadena = "SELECT Fecha FROM TSesiones where token = '%s'" % (str(token))
              fechaRefresh = query_select(cadena)
              refresco()
         
              time.sleep(5)

      CloseSession(token)
      
  return   
            
def ActivarThreadControlSession():
    timerThread = threading.Thread(target=ControlSession)
    timerThread.daemon = True
    timerThread.start()


@app.before_request
def db_connect():
  g.conn = mariadb.connect(host='localhost', user='pi', passwd='pirulaloka',db='DOMOTIC')
  g.cursor = g.conn.cursor()
  
@app.after_request
def db_disconnect(response):
  g.cursor.close()
  g.conn.close()
  return response

def Cerrar_bd():
  g.cursor.close()
  g.conn.close()

  
def query_fechas_token (query):
  try:
    g.cursor.execute(query)
    result = g.cursor.fethone()
    valor = result[3]
    return valor
  except Exception,e:
    logging.error("Error:", str(e))


def query_select(query):
  
  try:
    g.cursor.execute(query)
    result  = g.cursor.fetchone()
      
    num = result[0]
    
    return num
  except:
    return 0
  
def refresco():
  g.conn.commit()
       
def query_modificar2(query):
  
  g.cursor.execute(query)
  g.conn.commit()
  

def query_modificar(query):
  
  try:
    g.cursor.execute(query)
    g.conn.commit()
  except OSError as err:
    logging.error("OS error: {0}".format(err))
  except:
    logging.error("Unexpected error:", sys.exc_info()[0])
    raise

def RefrescarFechaSession():
  try:
    now = datetime.datetime.now() 
    fechaActualizada = now + datetime.timedelta(seconds=10)
    
    cadena = "UPDATE TSesiones SET Fecha = '%s' where Token = '%s'" % (str(fechaActualizada),str(token))
    
    result = query_modificar(cadena)
  except:
    logging.error("Unexpected error:", sys.exc_info()[0])
    raise
  

def ControlToken(token):
  
  
  print "token control token", token
  if token != "":
    cadena = "SELECT COUNT(*) FROM TSesiones where Token = '%s'" % str(token)
    resultado = query_select(cadena)
    return resultado
    
  else:
    return 0

@app.route('/eventos/<id>', methods=['GET'])
def GetEvento(id):
      
  if ControlToken(token) == 1:
  
    RefrescarFechaSession()
        
    result = query_select("SELECT * FROM TEvento where IdEvento=%d " % int(id)) 
    
    data = {'Resultado':[{'IdEvento': result}]}
    data = json.dumps(result)
    resp = Response(data, status=200, mimetype='application/json')
    return resp
       
  else:
    CodigoOper = int(OperationCode.Err.value)
    data = {'Resultado':[{'OperationCode': CodigoOper, 'Message': 'No acceso'}]}
    data = json.dumps(data)
    resp = Response(data, status=400, mimetype='application/json')
    return resp
  

def GenerarEvento(cadena):
  
  with app.app_context():
    db_connect()
  
  #Conectar()
    ahora = datetime.datetime.now()
    cadena = "INSERT INTO THistoricoEventos (Fecha, Descripcion) VALUES ('%s','%s')" % (str(ahora), str(cadena))
    query_modificar(cadena) 


@app.route('/validacionPin/<usuario>/<valor>', methods=['GET'])
def SegundaValidacion(usuario,valor):
  #ControlMail()
  global numeroEntero
  
  global passwordGlobal
  
  cadena = "SELECT COUNT(*) from TUsuarioPin where Usuario= '%s' and Pin ='%d'" % (str(usuario),int(valor))
  result = query_select(cadena)
  print cadena
      
  if result == 1:
    global now
    now2 = datetime.datetime.now()
    formatted_date = now2.strftime('%Y-%m-%d %H:%M:%S')
    ip = request.environ['REMOTE_ADDR']
                   
    global token
    token= generate_token(True)
    cadena = "SELECT IdUsuario FROM TUsuario where Usuario = '%s'" % (str(usuario))
    result = query_select(cadena)
                   
    idusuario = int(result)
          
    cadena2 = "INSERT INTO TSesiones (IdUsuario, Token, Fecha, Ip, Mac) VALUES ('%d','%s','%s','%s','AA-BB-CC-DD-EE')" % (idusuario,str(token),str(now2),ip)
                
    global idsession
          
    resultado= query_modificar(cadena2)
          
    global activarControlSession 
    activarControlSession = True
      
    ActivarThreadControlSession()
    GenerarEvento('Acesso OK')
    CodigoOper = int(OperationCode.Ok.value)
    data = {'Resultado':[{'OperationCode': CodigoOper, 'Message': 'pin', 'token': token}]}
    data = json.dumps(data)
    resp = Response(data, status=200, mimetype='application/json')
    return resp
          
  else:
    CodigoOper = int(OperationCode.BadUserPass.value)
    data = {'Resultado':[{'OperationCode': CodigoOper, 'Message': 'pin'}]}
    data = json.dumps(data)
    resp = Response(data, status=400, mimetype='application/json')
    return resp


def ControlMail(usuario):
  #print usuario
  numeroRandom = random.randint(1000, 9999)

  tamany = len(str(numeroRandom))
  numero = ' '
  if tamany == 4:
    numero = numeroRandom
  elif tamany == 3:
    numero = '0' + str(numero)
  elif tamany == 2:
    numero = '00' + str(numero)
  elif tamany == 1:
    numero = '000' + str(numero)
    
  global numeroEntero
  numeroEntero = int(numero)

  global passwordGlobal
  
  try:
    mail = "SELECT Mail from TUsuario where Usuario= '%s' and Password='%s'" % (str(usuario),str(passwordGlobal))
    mailDestino = query_select(mail)
    # create message object instance
    msg = MIMEMultipart()

    message = "El PIN generado es: %d" % (numeroEntero)
    
    # setup the parameters of the message
    password = "AfricaLopez2018"
    msg['From'] = "jmlopezcas@gmail.com"
    msg['To'] = mailDestino
    msg['Subject'] = "Autentificacion DOMOTIC."
    # add in the message body
    msg.attach(MIMEText(message, 'plain'))
    #create server
    server = smtplib.SMTP('smtp.gmail.com: 587')
    server.starttls()
    # Login Credentials for sending the mail
    server.login(msg['From'], password)
    # send the message via the server.
    server.sendmail(msg['From'], msg['To'], msg.as_string())
    server.quit()
    
    fecha = datetime.datetime.now()
    cadena = "INSERT INTO TUsuarioPin (Usuario, Pin, Fecha) VALUES ('%s','%d','%s')" % (str(usuario),(numeroEntero), str(fecha))
    resultado = query_modificar(cadena)
  except:
    print "error mail"

@app.route('/session/<usuario>/<password>', methods=['GET'])
def InitSession(usuario,password):
  global passwordGlobal
  passwordGlobal = password
  
  cadena = "SELECT IdUsuario from TUsuario where Usuario= '%s' and Password='%s'" % (str(usuario),str(password))
  resultado = query_select(cadena)
  #print 'Incio de sesion del usuario', usuario
  
  if resultado == 0:
    #USUARIO NO ENCONTRADO-> FIN
    CodigoOper = int(OperationCode.BadUserPass.value)
    data = {'Resultado':[{'OperationCode': CodigoOper, 'Message': 'login'}]}
    data = json.dumps(data)
    resp = Response(data, status=400, mimetype='application/json')
    return resp
    exit
    
  else:
    #USUARIO ENCONTRADO -> COMPROBAR SI HAY SESIONES CON ESE USUARIO
    idUsuario = resultado
     
    cade3 = "SELECT COUNT(*) from TSesiones where IdUsuario= '%d'"  % (idUsuario)
    resultado = query_select(cade3)
           
    if resultado >= 1:
      #HAY UNA SESION CON ESE USUARIO -> NO ENTRAR
      CodigoOper = int(OperationCode.ExistSession.value)
      data = {'Resultado':[{'OperationCode': CodigoOper, 'Message': 'login'}]}
      data = json.dumps(data)
      resp = Response(data, status=400, mimetype='application/json')
      return resp
      
      
    else:
      #USUARIO EXISTE Y NO HAY SESION -> SEGUNDA VALIDACION
      
      ControlMail(usuario)
      
      CodigoOper = int(OperationCode.Ok.value)
      data = {'Resultado':[{'OperationCode': CodigoOper, 'Message': 'login'}]}
      data = json.dumps(data)
      resp = Response(data, status=200, mimetype='application/json')
      return resp
          


class OperationCode(Enum):
   Ok = 0
   BadUserPass = 1
   Ip= 2
   ExistSession = 3
   Err = -1
   
class TipoDispositivo(Enum):
  Rele = 1
  Sensor = 2
  Flotador = 3
  
class EstadoSensor(Enum):
  Fallo = 0
  OK = 1
  

def CloseSession(token):
  
  try:
    cadena = "DELETE FROM TSesiones WHERE Token = '%s'" % str(token)
    res = query_modificar(cadena)
    session.clear()
    logging.debug('Cierre de la sesion', token)
    GenerarEvento('Cierre de la sesion', token)
  except:
    return 
    
  
@app.route('/sensor/<sensorId>/<token>', methods=['GET'])
def GetEstadoSensor(sensorId,token):
  
  cadena2 = "SELECT INTO TEstados (Nombre, Descripcion, Estado) VALUES ('%d','%s','%d','%d')" % ("Sensor",'Sensor temperatura activo',1)
  resultado= query_modificar(cadena2)
  CodigoOper = int(OperationCode.OK.value)
  data = {'Resultado':[{'OperationCode': 0,'Sensor': 'sensor', 'Descripcion': 'activo', 'Message' : 'EstadoSensor'}]}
  #data = {'Resultado':[{'Sensor:': sensorId, 'Rele': 'activo'}]}
  data = json.dumps(data)
  resp = Response(data, status=200, mimetype='application/json')
      
  return resp
  
    
  

@app.route('/salidas/<sensorId>/<activar>/<token>', methods=['GET'])
def ActivarSalida(sensorId,activar,token):
  
  if ControlToken(token) == 1: 
      RefrescarFechaSession()
  
      sensor = int(sensorId)
      
      sensor = 23 #solo hay uno configurado
      GPIO.setmode(GPIO.BCM)
      GPIO.setup(sensor, GPIO.OUT)
      
      logging.info('Se activa rele')
      GenerarEvento('Se activa rele')
      try:  
        GPIO.output(sensor, GPIO.HIGH)
        logging.info('Se activa rele')
        time.sleep(5)
        GPIO.output(sensor, GPIO.LOW)
        time.sleep(5)
        
        #CodigoOper = int(OperationCode.OK.value)
        data = {'Resultado':[{'OperationCode': 0,'Sensor': sensor, 'Rele': 'activo', 'Message' : 'ActivarSalida'}]}
        #data = {'Resultado':[{'Sensor:': sensorId, 'Rele': 'activo'}]}
        data = json.dumps(data)
        resp = Response(data, status=200, mimetype='application/json')
        
        return resp
    
      except KeyboardInterrupt:
        logging.Debug('Fallo en activacion rele')
        GPIO.cleanup()  #devuelve los pines a su estado inicial

  
  
def KeepAlive(arr, token):
  return str("IMPLEMENTAR")
  
def CargarLogConfig(fichero):
  
  if path.exists(fichero):
    logging.basicConfig(filename='domotic.log',level=logging.DEBUG,
                            format="%(asctime)s %(levelname)s %(threadName)s %(name)s %(message)s")
    logging.basicConfig(filename='domotic.log', filemode='a', format='%(name)s - %(levelname)s - %(message)s')
    logging.info('Arranque de la aplicacion')
    GenerarEvento('Inicio sesion')
  else:
    logging.basicConfig(filename='domotic.log',level=logging.DEBUG,
                            format="%(asctime)s %(levelname)s %(threadName)s %(name)s %(message)s")
    logging.basicConfig(filename='domotic.log', filemode='w', format='%(name)s - %(levelname)s - %(message)s')
    logging.debug('Arranque de la aplicacion')
    GenerarEvento('Inicio sesion')



def generate_token(bool):
	if  True:
		return str(uuid.uuid4()).replace('-', '')
  
if __name__ == '__main__':
    # ~ Carga de logs
    CargarLogConfig(filePath)
    #Control agua
    ActivarThreadControlFlotador()
    #Control ambiente
    ActivarThreadAmbiente()
    
    app.run(ssl_context=('cert.pem', 'key.pem'),debug=False, port=5000, host='0.0.0.0')

    
    
    
